/*
                        Copyright (c) 1994 by
                        Advanced Visual Systems Inc.
                        All Rights Reserved
        
        This software comprises unpublished confidential information of
        Advanced Visual Systems Inc. and may not be used, copied or made
        available to anyone, except in accordance with the license
        under which it is furnished.
        
        This file is under Perforce control
        $Id: //depot/express/fcs992/include/avs/gd.h#1 $
*/

#ifndef GD_INCLUDED
#define GD_INCLUDED

#include <avs/port.h>

/* mat operations header file */
#include <avs/mat.h>

/* Defines the renderers that we are to use */
#include <avs/gd_ren.h>

/**********************************************/
/* Forward typedef declarations               */
/* Needed because of so many cross references */
/**********************************************/

typedef struct _GDview GDview;
typedef struct _GDwinfo GDwinfo;
typedef struct _GDlight_info GDlight_info;
typedef struct _GDlight GDlight;
typedef struct _GDcamera GDcamera;
typedef struct _GDoutput GDoutput;
typedef struct _GDprtOutput GDprtOutput;
typedef struct _GDvrmlOutput GDvrmlOutput;
typedef struct _GDfieldOutput GDfieldOutput;
typedef struct _GDfileOutput GDfileOutput;
typedef struct _GDviewAttrs GDviewAttrs;
typedef struct _GDobject GDobject;
typedef struct _GDobj_list GDobj_list;
typedef struct _GDobj_sel GDobj_sel;
typedef struct _GDprops GDprops;
typedef struct _GDcolor GDcolor;
typedef struct _GDmodes GDmodes;
typedef struct _GDtexture GDtexture;
typedef struct _GDxform GDxform;
typedef struct _GDtrack_edit GDtrack_edit;
typedef struct _GDpick_data GDpick_data;
typedef struct _GDpick_info GDpick_info;
typedef struct _GDgeom_data GDgeom_data;
typedef struct _GDcache GDcache;
typedef struct _GDcache_block GDcache_block;
typedef struct _GDcache_header GDcache_header;
typedef struct _GDstack GDstack;
typedef struct _GDclip GDclip;
typedef struct _GDstate_lights GDstate_lights;
typedef struct _GDstate GDstate;

/* new flipbook structures */
typedef struct _GDframe    GDframe;
typedef struct _GDflipbook GDflipbook;

#ifdef MSDOS
#ifdef __cplusplus
#include <afxwin.h>
#else
#include <windows.h>
#endif
#undef min
#undef max
#else
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <avs/RenderV.h>
#endif

#include <avs/pal.h>		/* Need virtual palette stuff */
#include <avs/gd_def.h>
#include <avs/gd_str.h>

#ifdef __cplusplus
extern "C" {
#endif

/*****************************************************/
/*                 GD Functions                      */
/*****************************************************/

/* defined in gd/bounds.c */
void	GDdraw_bounds PTARGS((GDobject *, GDgeom_data *, GDstate *));
void	GDdraw_bounds_altobj PTARGS((GDview *, GDobject *));

/* defined in gd/fld_util.c */
int	GDfld_get_coord_extents PTARGS((GDobject *));
void	GDfld_get_node_data PTARGS((OMobj_id, GDgeom_data *));
int	GDfld_get_node_data_minmax PTARGS((OMobj_id, double *, double *));
void	GDfld_get_node_data_ids PTARGS((OMobj_id, GDgeom_data *));
int	GDfld_get_pick_node_data PTARGS((OMobj_id, int *, int *, char **));
void	GDfld_get_cell_data PTARGS((OMobj_id, GDgeom_data *));
int	GDfld_get_cell_data_minmax PTARGS((OMobj_id, double *, double *));
void	GDfld_get_cell_data_ids PTARGS((OMobj_id, GDgeom_data *));

/* defined in gd/geom.m */
void    GDinit_geom_data PTARGS((GDgeom_data *, GDstate *));
void    GDinit_geom_renderer_data PTARGS((GDgeom_data *, GDstate *));
void    GDbuild_geom_renderer_data PTARGS((GDobject *obj, GDgeom_data *data, GDstate *state));
void	GDfree_geom_data PTARGS((GDgeom_data *));
void    GDfree_cache_geom_data PTARGS((GDgeom_data *));
int     GDdata_size PTARGS((int));
void	GDincr_geom_data PTARGS((GDgeom_data *));

/* defined in gd/dmap_utl.c */
void    GDgen_colors PTARGS((int, int, char *, OMobj_id, float *));
void    GDgen_argbs PTARGS((OMobj_id, char *, int, unsigned int *, unsigned int, 
			    unsigned int, unsigned int, unsigned int, short *));
void    GDgen_rgbas PTARGS((OMobj_id, char *, int, unsigned int *, unsigned int, 
			    unsigned int, unsigned int, unsigned int, short *));
int	GDgen_pixels PTARGS((OMobj_id, PALvirt *, unsigned int *));
int	GDdmap_get_byte_argbs PTARGS((OMobj_id, unsigned int **));
int	GDdmap_get_short_argbs PTARGS((OMobj_id, unsigned int **, int *));
int	GDdmap_get_func PTARGS((OMobj_id, char *, OMpfi *, void *));
int	GDdmap_get_minmax PTARGS((OMobj_id, double *, double *));

/* defined in gd/gather.m */
char *  GDgather_convert PTARGS((GDobject *, GDstate *, char *, int, int *, char *,
		int, int, int, int, int));
char *	GDgather PTARGS((GDobject *, GDstate *, char *, int, int *, char *, int, int, int, int));
char *  GDgraph_gather PTARGS((GDobject *, GDstate *, char *, int *, char *, int, int, int, int));
char *  GDgraph_gather_cells PTARGS((GDobject *, GDstate *, char *, int *, char *, int, int, 
		int, int, int));
int     GDremove_null_cells PTARGS((int, int **, int, GDgeom_data *, int));
void	GDfree_null_cells PTARGS((GDgeom_data *, int *));
int	GDremove_null_strip_nodes PTARGS((int, int, int, GDgeom_data *, int **));
int	GDremove_null_line_nodes PTARGS((int, int, int, GDgeom_data *, int *, int *, int **, int **));

/* Defined in gd/view.c */
OMobj_id GDview_create PTARGS((OMobj_id));
int	GDview_init PTARGS((OMobj_id));
int	GDview_delete PTARGS((OMobj_id));
int	GDview_update PTARGS((OMobj_id));
void	GDview_render PTARGS((GDview *));
int 	GDview_status PTARGS((GDview *));
void	GDview_clear_status PTARGS((GDview *));
int 	GDview_is_active PTARGS((GDview *));
int	GDview_pick PTARGS((OMobj_id));
int	GDview_event PTARGS((OMobj_id));
#ifndef MSDOS
void	GDview_expose_event PTARGS((Widget, XtPointer, XEvent *, Boolean *));
void	GDview_resize_event PTARGS((Widget, XtPointer, XConfigureEvent *, Boolean *));
void	GDview_visibility_event PTARGS((Widget, XtPointer, XVisibilityEvent *, Boolean *));
#endif
int	GDview_update_virtpal PTARGS((OMobj_id));
int	GDview_build_view PTARGS((GDview *));

int	GDview_call_func PTARGS((GDview *, char *, int));
int	GDview_get_func PTARGS((GDview *, char *, OMpfi *));
int	GDoutput_get_func PTARGS((GDview *, char *));
int	GDoutput_get_writefunc PTARGS((GDview *, char *, int *, char *, char *));
int	GDprim_get_func PTARGS((GDview *, char *, OMpfi *));
int	GDview_pal_func PTARGS((GDview *));
void	GDview_update_buffers PTARGS((GDview *));
void	GDview_update_cameras PTARGS((GDview *));
void	GDview_update_output PTARGS((GDview *));
void	GDview_update_pick_ctrl PTARGS((GDview *));
void	GDview_update_light_info PTARGS((GDview *));
void	GDview_update_objects PTARGS((GDview *));
void	GDview_update_picked_info PTARGS((GDview *, int, OMobj_id *, OMobj_id *));
void	GDview_picked_info_valid PTARGS((GDview *));
void	GDview_update_view PTARGS((GDview *));
void	GDview_update_true_scale PTARGS((GDview *));
void	GDview_concat_true_scale_matrix PTARGS((GDview *, GDcamera *, float[4][4]));
int	GDview_set_renderer PTARGS((OMobj_id, int));
void	GDview_get_renderer PTARGS((OMobj_id, int *));
int	GDview_set_accel PTARGS((OMobj_id, int));
void	GDview_get_accel PTARGS((OMobj_id, int *));
int	GDview_set_timer PTARGS((OMobj_id, int));
void	GDview_get_timer PTARGS((OMobj_id, int *));
int	GDview_set_pcache PTARGS((OMobj_id, int));
void	GDview_get_pcache PTARGS((OMobj_id, int *));
int	GDview_set_render_mode PTARGS((OMobj_id, int));
void	GDview_get_render_mode PTARGS((OMobj_id, int *));
int	GDview_set_buffer_mode PTARGS((OMobj_id, int));
void	GDview_get_buffer_mode PTARGS((OMobj_id, int *));
int     GDview_set_back_color PTARGS((OMobj_id, float *));
void    GDview_get_back_color PTARGS((OMobj_id, float *));
int	GDview_set_output PTARGS((OMobj_id, int));
void	GDview_get_output PTARGS((OMobj_id, int *));
int	GDview_set_aspect PTARGS((OMobj_id, int));
void	GDview_get_aspect PTARGS((OMobj_id, int *));
void	GDview_set_stereo PTARGS((OMobj_id, int));
void	GDview_get_stereo PTARGS((OMobj_id, int *));
void	GDview_set_video PTARGS((OMobj_id, int));
void	GDview_get_video PTARGS((OMobj_id, int *));
void	GDview_get_video_off PTARGS((OMobj_id, int *));
void	GDview_set_video_off PTARGS((OMobj_id, int));
void	GDview_set_stereo_distance PTARGS((OMobj_id, float));
void	GDview_get_stereo_distance PTARGS((OMobj_id, float *));
void	GDview_set_stereo_angle PTARGS((OMobj_id, float));
void	GDview_get_stereo_angle PTARGS((OMobj_id, float *));
int	GDview_set_refresh PTARGS((OMobj_id));
int	GDview_get_time PTARGS((int, char *));
int     GDview_set_config_flags PTARGS((GDview *, int, int, int, int));
int	GDview_set_ts_enable PTARGS((OMobj_id, int));
void	GDview_get_ts_enable PTARGS((OMobj_id, int *));
void	GDview_set_ts_scale PTARGS((OMobj_id, int ));
void	GDview_get_ts_scale PTARGS((OMobj_id, int *));
void	GDview_set_ts_xorig PTARGS((OMobj_id, float));
void	GDview_get_ts_xorig PTARGS((OMobj_id, float *));
void	GDview_set_ts_yorig PTARGS((OMobj_id, float));
void	GDview_get_ts_yorig PTARGS((OMobj_id, float *));
void	GDview_set_blend_mode PTARGS((OMobj_id, int));
void	GDview_get_blend_mode PTARGS((OMobj_id, int *));

/* Defined in gd/view_att.c */
void	GDview_attach_camera PTARGS((OMobj_id, OMobj_id, int));
void	GDview_detach_cameras PTARGS((OMobj_id));
void	GDview_detach_camera PTARGS((OMobj_id, OMobj_id));
void	GDview_attach_light_info PTARGS((OMobj_id, OMobj_id, int));
void	GDview_detach_light_info PTARGS((OMobj_id, int));
void	GDview_attach_output PTARGS((OMobj_id, OMobj_id, int));
void	GDview_detach_output PTARGS((OMobj_id, int));
void	GDview_attach_object PTARGS((OMobj_id, OMobj_id, int));
void	GDview_detach_objects PTARGS((OMobj_id));
void	GDview_detach_object PTARGS((OMobj_id, OMobj_id));
void	GDview_attach_pick_ctrl PTARGS((OMobj_id, OMobj_id, int));
void	GDview_detach_pick_ctrl PTARGS((OMobj_id, int));
void	GDview_attach_virtpal PTARGS((OMobj_id, OMobj_id, int));
void	GDview_detach_virtpal PTARGS((OMobj_id, int));

/* Defined in gd/handle.c */
OMobj_id GDhandle_create PTARGS(());
void	GDhandle_delete PTARGS((OMobj_id));
void	GDview_attach_handle PTARGS((OMobj_id, OMobj_id));
void	GDview_detach_handle PTARGS((OMobj_id));
void	GDhandle_set_widget PTARGS((OMobj_id, int));
void	GDhandle_set_window PTARGS((OMobj_id, int));
void	GDhandle_set_event PTARGS((OMobj_id, int));

/* Defined in gd/stack.c */
void	GDstack_create PTARGS((GDview *));
void	GDstack_delete PTARGS((GDview *));
void	GDstack_init PTARGS((GDview *));
void	GDstack_enable PTARGS((GDview *, int));
void	GDstack_add_entry PTARGS((GDview *, char *, OMpfi, char *, int, char *));
void	GDstack_push PTARGS((GDview *view));
void	GDstack_pop PTARGS((GDview *view));

/* Defined in gd/state.c */
void	GDstate_create PTARGS((GDview *));
void	GDstate_init PTARGS((GDview *));
void	GDstate_delete PTARGS((GDview *));
int	GDstate_get_func PTARGS((GDview *, char *, OMpfi *));
void	GDstate_concat_obj_matrix PTARGS((GDview *, float [4][4]));
void	GDstate_set_dith_tech PTARGS((GDview *, int));
void	GDstate_set_interp_type PTARGS((GDview *, int));
void	GDstate_set_tmap_method PTARGS((GDview *, int));
void	GDstate_set_tri_subdiv PTARGS((GDview *, int));
void	GDstate_set_missing PTARGS((GDview *, float, float *));
void	GDstate_set_drawable PTARGS((GDview *, int));
void	GDstate_set_clip_plane_status PTARGS((GDview *, int, int));
void	GDstate_set_cmap PTARGS((GDview *, OMobj_id *));
void	GDstate_set_color PTARGS((GDview *, float *));
void	GDstate_set_highlight_colors PTARGS((GDview *, float *));
void	GDstate_set_draw_mode PTARGS((GDview *, int));
void	GDstate_set_line_width PTARGS((GDview *, int));
void	GDstate_set_line_style PTARGS((GDview *, int));
void    GDstate_set_line_aa PTARGS((GDview *, int));
void	GDstate_set_font PTARGS((GDview *, char *));
void	GDstate_set_depth_cue PTARGS((GDview *, int));
void	GDstate_set_lights PTARGS((GDview *));
void	GDstate_set_material PTARGS((GDview *, float *));
void	GDstate_set_mode PTARGS((GDview *, int *));
void	GDstate_set_mode_normals PTARGS((GDview *, int));
void	GDstate_set_mode_outline PTARGS((GDview *, int));
void	GDstate_set_obj_matrix PTARGS((GDview *, float [4][4]));
void	GDstate_set_pick PTARGS((GDview *, GDcamera *, int, int, int));
void	GDstate_set_pick_ray PTARGS((GDview *));
void	GDstate_set_specular_color PTARGS((GDview *, float *));
void	GDstate_set_texture PTARGS((GDview *, GDtexture *, float[4][4]));
void	GDstate_set_transparency PTARGS((GDview *, float *));
void 	GDstate_set_dir_pt_size PTARGS((GDview *, float *));
void    GDstate_set_subdiv PTARGS((GDview *, int));
void	GDstate_set_backface_cull PTARGS((GDview *, int));
void    GDstate_set_jitter PTARGS((GDview *, int));
void	GDstate_set_vox_interp PTARGS((GDview *, int));
void	GDstate_set_ray_algo PTARGS((GDview *, int));
void	GDstate_set_ray_norm PTARGS((GDview *, int));
void	GDstate_set_blend_mode PTARGS((GDview *, int));
void	GDstate_set_fat_ray PTARGS((GDview *, int));
void	GDstate_set_sfp_absorb PTARGS((GDview *, float *));
void	GDstate_set_sfp_emit PTARGS((GDview *, float *));
void	GDstate_update_matrix PTARGS((GDview *));
void 	GDstate_set_viewport PTARGS((GDview *, float *));
void	GDstate_set_stereo_attrs PTARGS((GDview *, float, float));

/* Defined in gd/cam.c */
void	GDcamera_create PTARGS((OMobj_id));
int	GDcamera_delete PTARGS((OMobj_id));
void	GDcamera_reset PTARGS((OMobj_id));
int	GDcamera_update PTARGS((OMobj_id));
void	GDcamera_notify_views PTARGS((GDcamera *));
void	GDcamera_notify_viewlist PTARGS((GDcamera *));
void	GDcamera_notify_virtpal PTARGS((GDcamera *));
void	GDcamera_update_camera PTARGS((GDcamera *));
void	GDcamera_update_depth_cue PTARGS((GDcamera *));
void	GDcamera_update_objects PTARGS((GDcamera *));
void	GDcamera_update_xform PTARGS((GDcamera *));
void	GDcamera_update_viewport PTARGS((GDcamera *));
void	GDcamera_3d_render1 PTARGS((GDview *, GDcamera *));
void	GDcamera_3d_render_2d PTARGS((GDview *, GDcamera *));
void	GDcamera_2d_render1 PTARGS((GDview *, GDcamera *));
void	GDcamera_3d_render_static PTARGS((GDview *, GDcamera *));
void	GDcamera_3d_render_dynamic PTARGS((GDview *, GDcamera *));
void	GDcamera_2d_render_static PTARGS((GDview *, GDcamera *));
void	GDcamera_2d_render_dynamic PTARGS((GDview *, GDcamera *));
void	GDcamera_set_attrs PTARGS((GDview *, GDcamera *, int));
void	GDcamera_pick PTARGS((GDview *, GDcamera *, int, OMobj_id *, int *, OMobj_id * ));
void	GDcamera_pick_reset PTARGS((GDcamera *));
int 	GDcamera_status PTARGS((GDcamera *, int, int, int, int));
void	GDcamera_clear_status PTARGS((GDcamera *));
int 	GDcamera_is_active PTARGS((GDcamera *));
void	GDcamera_auto_norm PTARGS((GDcamera *, int));

void	GDcamera_set_type PTARGS((OMobj_id, int));
void	GDcamera_get_type PTARGS((OMobj_id, int *));
void	GDcamera_set_render_mode PTARGS((OMobj_id, int));
void	GDcamera_get_render_mode PTARGS((OMobj_id, int *));
void	GDcamera_set_refresh PTARGS((OMobj_id));
void	GDcamera_set_from PTARGS((OMobj_id, float *));
void	GDcamera_get_from PTARGS((OMobj_id, float *));
void	GDcamera_set_up PTARGS((OMobj_id, float *));
void	GDcamera_get_up PTARGS((OMobj_id, float *));
void	GDcamera_set_at PTARGS((OMobj_id, float *));
void	GDcamera_get_at PTARGS((OMobj_id, float *));
void	GDcamera_set_scale PTARGS((OMobj_id, float));
void	GDcamera_get_scale PTARGS((OMobj_id, float *));
void	GDcamera_set_perspec PTARGS((OMobj_id, int));
void	GDcamera_get_perspec PTARGS((OMobj_id, int *));
void	GDcamera_set_hither PTARGS((OMobj_id, int));
void	GDcamera_get_hither PTARGS((OMobj_id, int *));
void	GDcamera_set_front PTARGS((OMobj_id, float));
void	GDcamera_get_front PTARGS((OMobj_id, float *));
void	GDcamera_set_back PTARGS((OMobj_id, float));
void	GDcamera_get_back PTARGS((OMobj_id, float *));
void	GDcamera_set_fov PTARGS((OMobj_id, float));
void	GDcamera_get_fov PTARGS((OMobj_id, float *));
void	GDcamera_set_wsize PTARGS((OMobj_id, float));
void	GDcamera_get_wsize PTARGS((OMobj_id, float *));
void	GDcamera_set_depth_cue PTARGS((OMobj_id, int));
void	GDcamera_get_depth_cue PTARGS((OMobj_id, int *));
void	GDcamera_set_depth_front PTARGS((OMobj_id, float));
void	GDcamera_get_depth_front PTARGS((OMobj_id, float *));
void	GDcamera_set_depth_back PTARGS((OMobj_id, float));
void	GDcamera_get_depth_back PTARGS((OMobj_id, float *));
void	GDcamera_set_depth_scale PTARGS((OMobj_id, float));
void	GDcamera_get_depth_scale PTARGS((OMobj_id, float *));
void	GDcamera_set_auto_norm PTARGS((OMobj_id, int));
void	GDcamera_get_auto_norm PTARGS((OMobj_id, int *));
void	GDcamera_set_norm_scale PTARGS((OMobj_id, float));
void	GDcamera_get_norm_scale PTARGS((OMobj_id, float *));
void	GDcamera_set_norm_invisible PTARGS((OMobj_id, int));
void	GDcamera_get_norm_invisible PTARGS((OMobj_id, int *));
void	GDcamera_set_extents PTARGS((OMobj_id, int));
void	GDcamera_get_extents PTARGS((OMobj_id, int *));
void	GDcamera_set_mapping PTARGS((OMobj_id, int));
void	GDcamera_get_mapping PTARGS((OMobj_id, int *));
int	GDcamera_set_image_pass PTARGS((OMobj_id, int));
void	GDcamera_get_image_pass PTARGS((OMobj_id, int *));
int	GDcamera_set_pickable PTARGS((OMobj_id, int));
void	GDcamera_get_pickable PTARGS((OMobj_id, int *));
void	GDcamera_set_jitter_scale PTARGS((OMobj_id, float));
void	GDcamera_get_jitter_scale PTARGS((OMobj_id, float *));

/* Defined in gd/cam_att.c */
void	GDcamera_attach_object PTARGS((OMobj_id, OMobj_id, int));
void	GDcamera_detach_objects PTARGS((OMobj_id));
void	GDcamera_detach_object PTARGS((OMobj_id, OMobj_id));
void	GDcamera_attach_xform PTARGS((OMobj_id, OMobj_id, int));
void	GDcamera_detach_xform PTARGS((OMobj_id, int));
void	GDcamera_detach_views PTARGS((OMobj_id));

/* Defined in gdif/cam_int.c */
void	GDcamera_set_orient PTARGS((GDcamera *));
void	GDcamera_set_project PTARGS((GDcamera *));
void	GDcamera_set_matrix PTARGS((GDcamera *));
void	GDcamera_get_orient PTARGS((GDcamera *));
float	GDcamera_compute_depth_value PTARGS((GDcamera *, float));

/* Defined in gd/object.c */
int	GDobject_create PTARGS((OMobj_id));
int	GDobject_delete PTARGS((OMobj_id));
int	GDobject_update PTARGS((OMobj_id));
int	GDobject_data PTARGS((OMobj_id));
void	GDobject_update_dmap PTARGS((GDobject *, int));
void	GDobject_update_props PTARGS((GDobject *, int));
void	GDobject_update_modes PTARGS((GDobject *, int));
void	GDobject_update_texture PTARGS((GDobject *, int));
void	GDobject_update_xform PTARGS((GDobject *, int));
void	GDobject_update_altxform PTARGS((GDobject *));
void	GDobject_update_txtrxform PTARGS((GDobject *));
void	GDobject_update_pick_info PTARGS((GDobject *, int));
void	GDobject_update_object PTARGS((GDobject *));
void	GDobject_update_children PTARGS((GDobject *));
void	GDobject_update_altobj PTARGS((GDobject *));
void	GDobject_update_data PTARGS((GDobject *));
void	GDobject_notify_views PTARGS((GDobject *));
void	GDobject_notify_viewlist PTARGS((GDobject *));
void	GDobject_notify_virtpal PTARGS((GDobject *));
int 	GDobject_status PTARGS((GDobject *, int, int, int, int, int));
void	GDobject_clear_status PTARGS((GDobject *));
int	GDobject_is_active PTARGS((GDobject *));
void	GDobject_auto_norm PTARGS((GDobject *, int));
void	GDobject_render PTARGS((GDview *, GDobject *, int));
void	GDobject_draw PTARGS((GDview *, GDobject *));
int     GDobject_get_render_method PTARGS((GDobject *));
void    GDobject_set_render_flags PTARGS((GDobject *));
int	GDobject_pick PTARGS((GDview *, GDcamera *, GDobject *, int, OMobj_id *, int *, OMobj_id *));
void	GDobject_pick_reset PTARGS((GDobject *));
void	GDobject_select PTARGS((GDview *, GDobject *));
void	GDobject_set_rspace PTARGS((GDobject *, int));
int	GDobject_set_visible PTARGS((OMobj_id, int));
void	GDobject_get_visible PTARGS((OMobj_id, int *));
int	GDobject_set_pickable PTARGS((OMobj_id, int));
void	GDobject_get_pickable PTARGS((OMobj_id, int *));
int     GDobject_set_www_url PTARGS((OMobj_id, char *));
void    GDobject_get_www_url PTARGS((OMobj_id, char **));
int     GDobject_set_www_label PTARGS((OMobj_id, char *));
void    GDobject_get_www_label PTARGS((OMobj_id, char **));
int	GDobject_set_cache PTARGS((OMobj_id, int));
void	GDobject_get_cache PTARGS((OMobj_id, int *));
int	GDobject_set_type PTARGS((OMobj_id, int));
void	GDobject_get_type PTARGS((OMobj_id, int *));
int	GDobject_set_dith_tech PTARGS((OMobj_id, int));
void	GDobject_get_dith_tech PTARGS((OMobj_id, int *));
int	GDobject_set_interp_type PTARGS((OMobj_id, int));
void	GDobject_get_interp_type PTARGS((OMobj_id, int *));
int	GDobject_set_altobj PTARGS((OMobj_id, int));
void	GDobject_get_altobj PTARGS((OMobj_id, int *));
int	GDobject_set_space PTARGS((OMobj_id, int));
void	GDobject_get_space PTARGS((OMobj_id, int *));
int	GDobject_set_tmap_method PTARGS((OMobj_id, int));
void	GDobject_get_tmap_method PTARGS((OMobj_id, int *));
int 	GDobject_set_tri_subdiv_type PTARGS((OMobj_id, int));
void 	GDobject_get_tri_subdiv_type PTARGS((OMobj_id, int *));
int 	GDobject_set_tri_subdiv_aval PTARGS((OMobj_id, int));
void 	GDobject_get_tri_subdiv_aval PTARGS((OMobj_id, int *));
int 	GDobject_set_tri_subdiv_fval PTARGS((OMobj_id, int));
void 	GDobject_get_tri_subdiv_fval PTARGS((OMobj_id, int *));
int	GDobject_set_missing_val PTARGS((OMobj_id, float));
void	GDobject_get_missing_val PTARGS((OMobj_id, float *));
int	GDobject_set_missing_rgb PTARGS((OMobj_id, float *));
void	GDobject_get_missing_rgb PTARGS((OMobj_id, float *));
int	GDobject_set_xform_mode PTARGS((OMobj_id, int));
void	GDobject_get_xform_mode PTARGS((OMobj_id, int *));
int	GDobject_set_window PTARGS((OMobj_id, float *));
void	GDobject_get_window PTARGS((OMobj_id, float *));
int	GDobject_set_surf_conv PTARGS((OMobj_id, int));
void	GDobject_get_surf_conv PTARGS((OMobj_id, int *));
int	GDobject_set_surf_chunk PTARGS((OMobj_id, int));
void	GDobject_get_surf_chunk PTARGS((OMobj_id, int *));
int	GDobject_set_surf_chunk_size PTARGS((OMobj_id, int));
void	GDobject_get_surf_chunk_size PTARGS((OMobj_id, int *));
int	GDobject_set_line_chunk_size PTARGS((OMobj_id, int));
void	GDobject_get_line_chunk_size PTARGS((OMobj_id, int *));
int 	GDobject_set_active PTARGS((OMobj_id, int));
int	GDobject_set_cache_size PTARGS((OMobj_id, int));
void	GDobject_get_cache_size PTARGS((OMobj_id, int *));
int	GDobject_set_surf_subdiv PTARGS((OMobj_id, int));
void	GDobject_get_surf_subdiv PTARGS((OMobj_id, int *));

/* Defined in gd/obj_att.c */
void	GDobject_attach_altobj PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_altobj PTARGS((OMobj_id, int));
void	GDobject_detach_cameras PTARGS((OMobj_id));
void	GDobject_attach_dmap PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_dmap PTARGS((OMobj_id, int));
void	GDobject_attach_modes PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_modes PTARGS((OMobj_id, int));
void	GDobject_attach_object PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_children PTARGS((OMobj_id));
void	GDobject_detach_parents PTARGS((OMobj_id));
void	GDobject_detach_object PTARGS((OMobj_id, OMobj_id));
void	GDobject_attach_pick_info PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_pick_info PTARGS((OMobj_id, int));
void	GDobject_attach_props PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_props PTARGS((OMobj_id, int));
void	GDobject_attach_texture PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_texture PTARGS((OMobj_id, int));
void	GDobject_detach_views PTARGS((OMobj_id));
void	GDobject_attach_xform PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_xform PTARGS((OMobj_id, int));
void	GDobject_attach_altxform PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_altxform PTARGS((OMobj_id, int));
void	GDobject_attach_txtrxform PTARGS((OMobj_id, OMobj_id, int));
void	GDobject_detach_txtrxform PTARGS((OMobj_id, int));

/* Defined in gd/obj_cach.c */
GDcache_header *GDcache_init PTARGS(());
GDcache_block *GDcache_new_block PTARGS((int));
char   *GDcache_malloc PTARGS((GDobject *, GDstate *, int));
void	GDobject_cache_append PTARGS((GDobject *, GDgeom_data *, GDstate *, int, OMpfi, int, OMpfi));
void	GDobject_cache_draw PTARGS((GDview *, GDobject *));
void	GDview_cache_delete PTARGS((GDview *));
void	GDobject_cache_check PTARGS((GDview *, GDobject *));
void	GDobject_cache_delete PTARGS((GDobject *));
void	GDobject_cache_free PTARGS((GDobject *));
void	GDobject_renderer_cache_free PTARGS((GDobject *, int));
int	GDcache_ref_inc PTARGS((GDcache_header *cache));
void	GDcache_ref_dec PTARGS((GDcache_header *cache));

/* flipbook extensions to cache */
GDcache_header *GDflipbook_cache_init PTARGS(());
char *GDflipbook_cache_malloc PTARGS((GDcache_header *, int));  
void GDflipbook_cache_append  PTARGS((GDview *, GDcache_header *, GDgeom_data *, int, int));
void GDflipbook_prim_func_2d_swap PTARGS((GDview *view, GDcache *cache));
void GDflipbook_prim_func_3d_swap PTARGS((GDview *view, GDcache *cache));

GDobject *GDflipbook_get_object PTARGS((GDview *view, OMobj_id camera_id, OMobj_id obj_id));

void GDflipbook_object_ext_center PTARGS((GDobject *obj));
void GDflipbook_object_ext_norm PTARGS((OMobj_id, GDobject *, int));
int GDflipbook_object_get_extent PTARGS((GDobject *obj, float xform[4][4], float extent[6], int flag));
int  GDflipbook_object_get_extent_world PTARGS((GDobject *obj, float extent[6], int flag));
/* general flipbook functions */
void GDview_set_flipbook_mode PTARGS((GDview *view , int flip_mode));
int  GDview_save_active_objects PTARGS((GDview *view));
int  GDview_restore_active_objects PTARGS((GDview *view));
int  GDview_set_flipbook_objects PTARGS((GDview *view));
int  GDview_get_number_of_frames  PTARGS((GDview *view));
int  GDview_set_flipbook_cPframe PTARGS((GDview *view, int frame_no));
int  GDview_get_flipbook_cPframe PTARGS((GDview *view));
int  GDview_get_flipbook_cCframe PTARGS((GDview *view));

int GDcamera_set_flipbook_frame PTARGS((GDcamera *camera, int frame_no));
int GDcamera_set_flipbook_objects PTARGS((GDcamera *camera));
int GDcamera_save_active_objects PTARGS((GDcamera *camera));
int GDcamera_restore_active_objects PTARGS((GDcamera *camera));
int GDcamera_flipbook_auto_norm PTARGS((GDcamera *camera, int flag));

void GDobject_flipbook_render PTARGS((GDview *view, GDobject *obj, int flag));

int ResetUniqueCacheID(int id);
int ResetUniqueTxtrID(int id);

void	GDtexture_ref_inc PTARGS((GDtexture *texture));
void	GDtexture_ref_dec PTARGS((GDtexture *texture));

/* Defined in gd/obj_util.c */
void	GDobject_ext_reset PTARGS((OMobj_id));
void	GDobject_ext_center PTARGS((OMobj_id, OMobj_id));
void	GDobject_ext_norm PTARGS((OMobj_id, OMobj_id, int));
int	GDobject_ext_compute PTARGS((OMobj_id, OMobj_id, float[6]));
int	GDobject_ext_compute_world PTARGS((OMobj_id, OMobj_id, float[6]));
int	GDobject_get_parent_xform PTARGS((OMobj_id, OMobj_id *, OMobj_id *));
void	GDobject_get_rotation PTARGS((OMobj_id, float [4][4]));
int	GDobject_get_transform PTARGS((OMobj_id, float [4][4], int));
int	GDobject_get_extent PTARGS((GDobject *, float [4][4], float [6], int, int));
int	GDobject_get_extent_world PTARGS((GDobject *, float [6], int, int));

/* Defined in gd/gd_init.c */
void	GDinit PTARGS((int *, char **));
int	GDinit_hardware_renderer PTARGS((void));

/* Defined in gd/output.c */
int	GDfield_output_create PTARGS((OMobj_id));
int	GDfield_output_delete PTARGS((OMobj_id));
int	GDfield_output_update PTARGS((OMobj_id));
int	GDfile_output_create PTARGS((OMobj_id));
int	GDfile_output_delete PTARGS((OMobj_id));
int	GDfile_output_update PTARGS((OMobj_id));
void	GDoutput_init PTARGS((GDview *));
void	GDoutput_flush PTARGS((GDview *));
void	GDfield_output_write PTARGS((int *, char *, char *, GDoutput *));
void	GDfile_output_write PTARGS((int *, char *, char *, GDoutput *));
void	GDoutput_done PTARGS((GDview *));

/* Defined in gd/roi.c */
int	GDroi2d_cont_create PTARGS((OMobj_id));
int	GDroi2d_cont_delete PTARGS((OMobj_id));
int	GDroi2d_cont_update PTARGS((OMobj_id));
int	GDroi2d_click_create PTARGS((OMobj_id));
int	GDroi2d_click_delete PTARGS((OMobj_id));
int	GDroi2d_click_update PTARGS((OMobj_id));
int	GDdraw2d_cursor_create PTARGS((OMobj_id));
int	GDdraw2d_cursor_delete PTARGS((OMobj_id));
int	GDdraw2d_cursor_update PTARGS((OMobj_id));
int	GDmap2d_ss_update PTARGS((OMobj_id));
int	GDedit_mesh_create PTARGS((OMobj_id));
int	GDedit_mesh_delete PTARGS((OMobj_id));
int	GDedit_mesh_update PTARGS((OMobj_id));
void	GDmap_ss_to_2dworld PTARGS((GDcamera *, float *, int, short *, float *));
void	GDmap_ss_to_3dworld PTARGS((GDcamera *, float *, int, short *, float *, float *, int));
void	GDmap_get_matrix PTARGS((GDview *, GDcamera *, GDobject *, float *, int));
int	GDmap2d_obj_concat PTARGS((GDview *, GDobject *, GDobject *, float *, int));
void	UTILclear_mesh PTARGS((OMobj_id));

/* Defined in gd/roi_conv.c */
int	GDvector2raster_update PTARGS((OMobj_id));

/* Defined in gd/mesh.c */
void	GDdraw_mesh_unif PTARGS((GDobject *, GDstate *));
void	GDdraw_mesh_rect PTARGS((GDobject *, GDstate *));
void	GDdraw_mesh PTARGS((GDobject *, GDstate *));
void	GDdraw_volume PTARGS((GDobject *, GDstate *));
void	GDpick_mesh PTARGS((GDobject *, GDstate *));
void	GDpick_mesh_unif PTARGS((GDobject *, GDstate *));
void	GDpick_volume PTARGS((GDobject *, GDstate *));

/* Defined in gd/mesh_arr.c */
void	GDdraw_mesh_array PTARGS((GDobject *, GDstate *));
void	GDpick_mesh_array PTARGS((GDobject *, GDstate *));
void	GDdraw_volume_tiled PTARGS((GDobject *, GDstate *));
void	GDpick_volume_tiled PTARGS((GDobject *, GDstate *));

/* Defined in gd/minmax.c */
int	GDminmax_update PTARGS((OMobj_id));
int	GDvol_minmax_update PTARGS((OMobj_id));
void	GDminmax_set_values PTARGS((OMobj_id, double, double));

/* Defined in gd/polyh.c */
void	GDdraw_polyh PTARGS((GDobject *, GDstate *));
void	GDpick_polyh PTARGS((GDobject *, GDstate *));

/* Defined in cell_3d.c */
int GDextract_2d_cells PTARGS((OMobj_id, OMobj_id, OMobj_id, int, int, int *));

/* Defined in gd/cells.c */
void	GDdraw_point_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_line_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_polyline_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_polytri_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_tri_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_quad_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_polyh_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDrender_surf  PTARGS((GDobject *, GDgeom_data *, GDstate *, int, int, int *, int *, int));
void	GDrender_lines_pts PTARGS((GDobject *, GDgeom_data *, GDstate *, int, int, int *, int *, int));
void	GDpolyh_gen_norms PTARGS((int, int, int *, int, float *, int, float **, int));
int	GDpick_point_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int     GDpick_line_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_polyline_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_polytri_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_tri_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_quad_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_polyh_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));

/* Defined in gd/cells2.c */
void	GDdraw_tri2_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_tri2_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDdraw_quad2_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
int	GDpick_quad2_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));

/* Defined in gd/quads.c */
void	GDtesselate_quad_cells PTARGS((GDobject *, OMobj_id, GDgeom_data *, GDstate *));
void	GDquad_init_shapes PTARGS((GDstate *));
void	GDquad_free_shapes PTARGS((GDstate *));

/* Defined in gd/gr_surf.c */
void GDgraph_cvt PTARGS((int, int, int *, int **, int **));
void GDgraph_cvt_thorough PTARGS((int, int, int *, int **, int **));

/* Defined in gd/gr_wire.c */
int GDgraph_cvt_wire PTARGS((int, int, int[], int[], int **, int **));

/* Defined in gd/text.c */
void	GDdraw_text PTARGS((GDobject *, GDstate *));
void	GDpick_text PTARGS((GDobject *, GDstate *));
void	GDdraw_text_array PTARGS((GDobject *, GDstate *));
void	GDpick_text_array PTARGS((GDobject *, GDstate *));
void    GDdraw_stroke_text PTARGS((GDobject *, GDstate *));
void    GDpick_stroke_text PTARGS((GDobject *, GDstate *));
void    GDdraw_stroke_text_array PTARGS((GDobject *, GDstate *));
void    GDpick_stroke_text_array PTARGS((GDobject *, GDstate *));
int	GDtext_stroke_get_extents PTARGS((GDobject *, GDtext **, GDstrokeText **, GDgeom_data *, int, int));

/* Defined in gd/pick.c */
void	GDpick_points PTARGS((GDgeom_data *, GDstate *));
void	GDpick_spheres PTARGS((GDgeom_data *, GDstate *));
void	GDpick_lines PTARGS((GDgeom_data *, GDstate *));
void	GDpick_polyline PTARGS((GDgeom_data *, GDstate *));
void	GDpick_wiretris PTARGS((GDgeom_data *, GDstate *));
void	GDpick_wirequads PTARGS((GDgeom_data *, GDstate *));
void	GDpick_polytri PTARGS((GDgeom_data *, GDstate *));
void	GDpick_tris PTARGS((GDgeom_data *, GDstate *));
void	GDpick_quads PTARGS((GDgeom_data *, GDstate *));
void	GDpick_polygon PTARGS((GDgeom_data *, GDstate *));
void	GDpick_2dimage PTARGS((GDgeom_data *, GDstate *));

/* Defined in gd/view_ed.c */
int	GDview_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/view_sel.c */
int GDview_selector_update PTARGS((OMobj_id, OMevent_mask, int));
int GDview_creator_create PTARGS((OMobj_id, OMevent_mask, int));
int GDview_creator_destroy PTARGS((OMobj_id, OMevent_mask, int));
int GDview_creator_view_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/obj_sel.c */
int	GDobj_sel_create PTARGS((OMobj_id));
int	GDobj_sel_delete PTARGS((OMobj_id));
int	GDobj_sel_update PTARGS((OMobj_id));
void	GDobj_get_obj_name PTARGS((OMobj_id, char *, int));

/* Defined in gd/obj_ed.c */
int	GDobj_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/cam_ed.c */
int	GDcamera_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/linfo_ed.c */
int	GDlinfo_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/light_ed.c */
int	GDlight_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/modes_ed.c */
int	GDmodes_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/props_ed.c */
int	GDprops_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/txtr_ed.c */
int	GDtexture_edit_update PTARGS((OMobj_id, OMevent_mask, int));

/* Defined in gd/track_ed.c */
int	GDtrack_edit_create PTARGS((OMobj_id));
int	GDtrack_edit_delete PTARGS((OMobj_id));
int	GDtrack_edit_update PTARGS((OMobj_id));
int	GDtrack_xlate PTARGS((GDtrack_edit *, int, int, int, int, float[4][4], float[3]));
int	GDtrack_zlate PTARGS((GDtrack_edit *, int, int, int, int, float[4][4], float[3]));
int 	GDtrack_begin PTARGS((GDtrack_edit *, OMobj_id, OMobj_id, OMobj_id, OMobj_id, int, int, int, int));
int	GDtrack_scale PTARGS((GDtrack_edit *, int, int, int, int, float[4][4], float[3]));
int	GDtrack_rotate PTARGS((GDtrack_edit *, int, int, int, int, float[4][4], float[3]));
void    GDtrack_set_timer PTARGS((int));
void	GDtrack_stop_roll PTARGS(());
int	GDtrack_rolling PTARGS(());

/* Defined in gd/xform_ed.c */
int	GDxform_edit_update PTARGS((OMobj_id, OMevent_mask, int));
void	GDxform_get_SR PTARGS((float[4][4], int *, float[3], int *, float[3]));

/* Defined in gd/x_winfo.c */
#ifdef MSDOS
int	GDwinfo_valid PTARGS((GDview *, int *, HWND *, HDC *));
void	GDwinfo_update PTARGS((GDview *, int, HWND, HDC));
#else
int	GDwinfo_valid PTARGS((GDview *, int *, Widget *, Window *, Display **));
int 	GDwinfo_window_changed PTARGS((GDview *));
void	GDwinfo_update PTARGS((GDview *, int, Widget, Window, Display *));
#endif
int	GDwinfo_window_valid PTARGS((GDview *));
int	GDwinfo_get_event PTARGS((GDview *, int *));
int	GDwinfo_create PTARGS((GDview *));
void	GDwinfo_delete PTARGS((GDview *));
void	GDwinfo_update_size PTARGS((GDview *));

/*****************************************************/
/*                GDIF Functions                     */
/*****************************************************/

/* Defined in gdif/om_util.c */
OMobj_id GDcreate_instance PTARGS((OMobj_id, char *, char *));
void	GDset_local PTARGS((OMobj_id, char *));
void	GDclear_local PTARGS((OMobj_id));
char *	GDget_local PTARGS((OMobj_id, OMpfi));
void	GDset_refer_db PTARGS((OMobj_id, char *, OMobj_id));
int	GDget_refer_db PTARGS((OMobj_id, char *, OMobj_id *));
int	GDget_seqref_db PTARGS((OMobj_id, char *, int, int *, OMobj_id *));
int	GDget_obj_seq PTARGS((OMobj_id, char *, int *, int));
void	GDset_int_val PTARGS((OMobj_id, char *, int));
int	GDget_int_val PTARGS((OMobj_id, char *, int *));
void	GDset_newint_val PTARGS((OMobj_id, char *, int *, int));
int	GDget_newint_val PTARGS((OMobj_id, char *, int *, int *));
int	GDget_updint_val PTARGS((OMobj_id, char *, int, int *));
int	GDget_updstr_val PTARGS((OMobj_id, char *, int, char **));
void	GDset_float_val PTARGS((OMobj_id, char *, float));
int	GDget_float_val PTARGS((OMobj_id, char *, float *));
void	GDset_newfloat_val PTARGS((OMobj_id, char *, int *, float));
int	GDget_newfloat_val PTARGS((OMobj_id, char *, int *, float *));
int	GDget_updfloat_val PTARGS((OMobj_id, char *, int, float *));
void	GDset_int_array PTARGS((OMobj_id, char *, int, int *));
int	GDget_newint_array PTARGS((OMobj_id, char *, int *, int *, int **));
int	GDget_updint_array PTARGS((OMobj_id, char *, int, int *, int **));
int	GDget_int_array PTARGS((OMobj_id, char *, int *, int **));
void	GDset_float_array PTARGS((OMobj_id, char *, int, float *));
int	GDget_newfloat_array PTARGS((OMobj_id, char *, int *, int *, float **));
int	GDget_updfloat_array PTARGS((OMobj_id, char *, int, int *, float **));
int	GDget_float_array PTARGS((OMobj_id, char *, int *, float **));
int	GDget_str_val PTARGS((OMobj_id, char *, char **));
void	GDset_newstr_val PTARGS((OMobj_id, char *, int *, char *));
int	GDget_newstr_val PTARGS((OMobj_id, char *, int *, char **));

/* Defined in gdif/lt_info.c */
int	GDlight_info_create PTARGS((OMobj_id));
int	GDlight_info_delete PTARGS((OMobj_id));
int	GDlight_info_update PTARGS((OMobj_id));
void	GDlight_info_reset PTARGS((OMobj_id));
void	GDlight_info_update_lights PTARGS((GDlight_info *));
void	GDlight_info_attach_light PTARGS((OMobj_id, OMobj_id, int));
void	GDlight_info_detach_light PTARGS((OMobj_id, OMobj_id, int));
void	GDlight_info_set_show PTARGS((OMobj_id, int));
void	GDlight_info_get_show PTARGS((OMobj_id, int *));
void	GDlight_info_set_amb_state PTARGS((OMobj_id, int));
void	GDlight_info_get_amb_state PTARGS((OMobj_id, int *));
void	GDlight_info_set_amb_color PTARGS((OMobj_id, float *));
void	GDlight_info_get_amb_color PTARGS((OMobj_id, float *));

/* Defined in gdif/light.c */
int	GDlight_create PTARGS((OMobj_id));
int	GDlight_delete PTARGS((OMobj_id));
int	GDlight_update PTARGS((OMobj_id));
void	GDlight_update_xform PTARGS((GDlight *));
void	GDlight_attach_xform PTARGS((OMobj_id, OMobj_id, int));
void	GDlight_detach_xform PTARGS((OMobj_id, int));
void	GDlight_reset PTARGS((OMobj_id));
void	GDlight_set_type PTARGS((OMobj_id, int));
void	GDlight_get_type PTARGS((OMobj_id, int *));
void	GDlight_set_state PTARGS((OMobj_id, int));
void	GDlight_get_state PTARGS((OMobj_id, int *));
void	GDlight_set_color PTARGS((OMobj_id, float *));
void	GDlight_get_color PTARGS((OMobj_id, float *));
void	GDlight_set_att PTARGS((OMobj_id, float *));
void	GDlight_get_att PTARGS((OMobj_id, float *));
void	GDlight_set_concen PTARGS((OMobj_id, float));
void	GDlight_get_concen PTARGS((OMobj_id, float *));
void	GDlight_set_angle PTARGS((OMobj_id, float));
void	GDlight_get_angle PTARGS((OMobj_id, float *));

/* Defined in gdif/pickctrl.c */
void	GDpick_ctrl_create PTARGS((OMobj_id));
void	GDpick_ctrl_reset PTARGS((OMobj_id));
void	GDpick_ctrl_set_mode PTARGS((OMobj_id, int));
void	GDpick_ctrl_get_mode PTARGS((OMobj_id, int *));
void	GDpick_ctrl_get_on_start PTARGS((OMobj_id, int *));
void	GDpick_ctrl_get_xy PTARGS((OMobj_id, int *, int *));
void	GDpick_ctrl_get_event PTARGS((OMobj_id, int *));

/* Defined in gdif/modes.c */
int	GDmodes_create PTARGS((OMobj_id));
int	GDmodes_delete PTARGS((OMobj_id));
void	GDmodes_reset PTARGS((OMobj_id));
int	GDmodes_update PTARGS((OMobj_id));
void	GDmodes_set_points PTARGS((OMobj_id, int));
void	GDmodes_set_lines PTARGS((OMobj_id, int));
void	GDmodes_set_surf PTARGS((OMobj_id, int));
void	GDmodes_set_volume PTARGS((OMobj_id, int));
void	GDmodes_set_bounds PTARGS((OMobj_id, int));
void	GDmodes_get_mode PTARGS((OMobj_id, int *));
void	GDmodes_set_normals PTARGS((OMobj_id, int));
void	GDmodes_get_normals PTARGS((OMobj_id, int *));
void	GDmodes_set_colors PTARGS((OMobj_id, int));
void	GDmodes_get_colors PTARGS((OMobj_id, int *));
void    GDmodes_set_outline PTARGS((OMobj_id, int));

/* Defined in gdif/props.c */
int	GDprops_create PTARGS((OMobj_id));
int	GDprops_delete PTARGS((OMobj_id));
void	GDprops_reset PTARGS((OMobj_id));
int	GDprops_update PTARGS((OMobj_id));
void    GDprops_set_font PTARGS((OMobj_id, char *));
void 	GDprops_set_color PTARGS((OMobj_id, float *));
void 	GDprops_get_color PTARGS((OMobj_id, float *));
void 	GDprops_set_hi1_col PTARGS((OMobj_id, float *));
void 	GDprops_get_hi1_col PTARGS((OMobj_id, float *));
void 	GDprops_set_hi2_col PTARGS((OMobj_id, float *));
void 	GDprops_get_hi2_col PTARGS((OMobj_id, float *));
void 	GDprops_set_material PTARGS((OMobj_id, float *));
void 	GDprops_get_material PTARGS((OMobj_id, float *));
void 	GDprops_set_specular_color PTARGS((OMobj_id, float *));
void 	GDprops_get_specular_color PTARGS((OMobj_id, float *));
void 	GDprops_set_transparency PTARGS((OMobj_id, float));
void 	GDprops_get_transparency PTARGS((OMobj_id, float *));
void 	GDprops_set_draw_mode PTARGS((OMobj_id, int));
void 	GDprops_get_draw_mode PTARGS((OMobj_id, int *));
void 	GDprops_set_line_width PTARGS((OMobj_id, int));
void 	GDprops_get_line_width PTARGS((OMobj_id, int *));
void 	GDprops_set_line_style PTARGS((OMobj_id, int));
void 	GDprops_get_line_style PTARGS((OMobj_id, int *));
void    GDprops_set_line_aa PTARGS((OMobj_id, int));
void    GDprops_get_line_aa PTARGS((OMobj_id, int *));
void 	GDprops_set_inherit PTARGS((OMobj_id, int));
void 	GDprops_get_inherit PTARGS((OMobj_id, int *));
void 	GDprops_set_dir_pt_size PTARGS((OMobj_id, float));
void 	GDprops_get_dir_pt_size PTARGS((OMobj_id, float *));
void    GDprops_set_subdiv PTARGS((OMobj_id, int));
void    GDprops_get_subdiv PTARGS((OMobj_id, int *));
void    GDprops_set_jitter PTARGS((OMobj_id, int));
void    GDprops_get_jitter PTARGS((OMobj_id, int *));
void	GDprops_set_cull PTARGS((OMobj_id, int));
void	GDprops_get_cull PTARGS((OMobj_id, int *));
void	GDprops_set_vox_interp PTARGS((OMobj_id, int));
void	GDprops_get_vox_interp PTARGS((OMobj_id, int *));
void	GDprops_set_ray_algo PTARGS((OMobj_id, int));
void	GDprops_get_ray_algo PTARGS((OMobj_id, int *));
void	GDprops_set_ray_norm PTARGS((OMobj_id, int));
void	GDprops_get_ray_norm PTARGS((OMobj_id, int *));
void	GDprops_set_fat_ray PTARGS((OMobj_id, int));
void	GDprops_get_fat_ray PTARGS((OMobj_id, int *));
void	GDprops_set_sfp_absorb PTARGS((OMobj_id, float));
void	GDprops_get_sfp_absorb PTARGS((OMobj_id, float *));
void	GDprops_set_sfp_emit PTARGS((OMobj_id, float));
void	GDprops_get_sfp_emit PTARGS((OMobj_id, float *));

/* Defined in gdif/texture.c */
int	GDtexture_create PTARGS((OMobj_id));
void    GDtexture_free_data PTARGS((GDtexture *));
void    GDtexture_free_colormap PTARGS((GDtexture *));
void    GDtexture_free PTARGS((GDtexture *));
int	GDtexture_delete PTARGS((OMobj_id));
void	GDtexture_reset PTARGS((OMobj_id));
int	GDtexture_update PTARGS((OMobj_id));
int     GDtexture_get_data PTARGS((GDtexture *));
int     GDtexture_get_colormap PTARGS((GDtexture *));
void    GDtexture_update_data PTARGS((GDtexture *));
void	GDtexture_update_colormap PTARGS((GDtexture *));
void 	GDtexture_set_tile PTARGS((OMobj_id, int));
void 	GDtexture_get_tile PTARGS((OMobj_id, int *));
void 	GDtexture_set_alpha PTARGS((OMobj_id, int));
void 	GDtexture_get_alpha PTARGS((OMobj_id, int *));
void 	GDtexture_set_filter PTARGS((OMobj_id, int));
void 	GDtexture_get_filter PTARGS((OMobj_id, int *));
void 	GDtexture_set_type PTARGS((OMobj_id, int));
void 	GDtexture_get_type PTARGS((OMobj_id, int *));
void 	GDtexture_set_stage PTARGS((OMobj_id, int));
void 	GDtexture_get_stage PTARGS((OMobj_id, int *));

/* Defined in gdif/xform.c */
GDxform *GDxform_alloc PTARGS((OMobj_id));
void	GDxform_reset PTARGS((OMobj_id));
void	GDxform_update PTARGS((OMobj_id, GDxform *));
void	GDxform_set_matrix PTARGS((OMobj_id, float [4][4]));
void	GDxform_concat_matrix PTARGS((OMobj_id, float [4][4]));
void	GDxform_get_matrix PTARGS((OMobj_id, float *));
void	GDxform_get_comp_matrix PTARGS((OMobj_id, float *));
void	GDxform_set_xlate PTARGS((OMobj_id, float [3]));
void	GDxform_concat_xlate PTARGS((OMobj_id, float [3]));
void	GDxform_get_xlate PTARGS((OMobj_id, float *));
void	GDxform_set_center PTARGS((OMobj_id, float [3]));
void	GDxform_concat_center PTARGS((OMobj_id, float [3]));
void	GDxform_get_center PTARGS((OMobj_id, float *));

/* Defined in gdif/pickinfo.c */
int	GDpick_info_create PTARGS((OMobj_id));
int	GDpick_info_delete PTARGS((OMobj_id));
void	GDpick_info_reset PTARGS((OMobj_id));
void	GDpick_info_add_pick_data PTARGS((GDstate *));
void	GDpick_info_set_matricies PTARGS((GDstate *, float [4][4]));
void	GDpick_info_set_ids PTARGS((GDstate *, GDpick_data *, OMobj_id, OMobj_id));
int	GDpick_info_update PTARGS((GDobject *, GDstate *, GDpick_info *, int, OMobj_id *));
void	GDpick_info_set_objxform PTARGS((OMobj_id, float [4][4]));
void	GDpick_info_get_objxform PTARGS((OMobj_id, float *));
void	GDpick_info_set_topxform PTARGS((OMobj_id, float [4][4]));
void	GDpick_info_get_topxform PTARGS((OMobj_id, float *));
void	GDpick_info_set_viewxform PTARGS((OMobj_id, float [4][4]));
void	GDpick_info_get_viewxform PTARGS((OMobj_id, float *));
void	GDpick_info_set_selected PTARGS((OMobj_id, int));
void	GDpick_info_get_selected PTARGS((OMobj_id, int *));
void	GDpick_info_set_npicked PTARGS((OMobj_id, int));
void	GDpick_info_get_npicked PTARGS((OMobj_id, int *));
void	GDpick_info_set_pickdata PTARGS((OMobj_id, int, GDpick_data *));
void	GDpick_info_get_pickdata PTARGS((OMobj_id, int, GDpick_data *));
void	GDpick_info_set_pickpath PTARGS((OMobj_id, int, OMobj_id *));
void	GDpick_info_set_toppath PTARGS((OMobj_id, OMobj_id, OMobj_id, OMobj_id));
void	GDpick_info_get_pickpath PTARGS((OMobj_id, int *, OMobj_id *));

/* Defined in gdif/track.c */
int	GDtrack_begin PTARGS((  GDtrack_edit*, OMobj_id, OMobj_id, OMobj_id, 
				OMobj_id, int, int, int, int));
int	GDtrack_xlate PTARGS((  GDtrack_edit*, 
				int, int, int, int, float [4][4], float [3]));
int	GDtrack_zlate PTARGS((  GDtrack_edit*,
				int, int, int, int, float [4][4], float [3]));
int	GDtrack_scale PTARGS((  GDtrack_edit*,
				int, int, int, int, float [4][4], float [3]));
int	GDtrack_rotate PTARGS(( GDtrack_edit*,
				int, int, int, int, float[4][4], float [3]));

/* Defined in gd/dpy_img.c */
int	GDdisplay_image PTARGS((OMobj_id));

#ifdef __cplusplus
}	/* extern "C" */
#endif

#endif	/* GD_INCLUDED */
